/*
 *      Interactive disassembler (IDA).
 *      Copyright (c) 1990-98 by Ilfak Guilfanov.
 *      ALL RIGHTS RESERVED.
 *                              E-mail: ig@estar.msk.su, ig@datarescue.com
 *                              FIDO:   2:5020/209
 *
 */

#include "st6.hpp"

instruc_t Instructions[] = {

{ "",		0								},      // Unknown Operation
{ "ld",		CF_USE1|CF_USE2|CF_CHG1			},      // Load value to A
{ "ldi",	CF_USE1|CF_USE2|CF_CHG1			},      // Load value to A
{ "add",	CF_USE1|CF_USE2|CF_CHG1			},      // Add Second Operand to Acc
{ "addi",	CF_USE1|CF_USE2|CF_CHG1			},      // Add Second Operand to Acc
{ "and",    CF_USE1|CF_USE2|CF_CHG1         },      // And Second Operand to Acc
{ "andi",   CF_USE1|CF_USE2|CF_CHG1         },      // And Second Operand to Acc
{ "clr",	CF_USE1|CF_CHG1					},      // Clear A
{ "com",	CF_USE1|CF_CHG1                 },      // complement A
{ "cp",		CF_USE1|CF_USE2					},      // Compare A with Operand
{ "cpi",	CF_USE1|CF_USE2					},      // Compare A with Operand
{ "dec",	CF_USE1|CF_CHG1					},      // decrement A
{ "inc",    CF_USE1|CF_CHG1					},      // increment A
{ "rlc",    CF_USE1|CF_CHG1                 },      // Rotate A through carry flag
{ "sla",    CF_USE1|CF_CHG1                 },      // shift A left with carry
{ "sub",    CF_USE1|CF_USE2|CF_CHG1         },      // Decrement Operand
{ "subi",   CF_USE1|CF_USE2|CF_CHG1         },      // Decrement Operand
{ "set",    CF_USE1|CF_USE2|CF_CHG2			},      // set bit
{ "res",	CF_USE1|CF_USE2|CF_CHG2			},      // reset bit
{ "jrc",	CF_USE1			                },      // jump if carry
{ "jrnc",	CF_USE1							},      // jump no carry
{ "jrz",	CF_USE1			                },      // jump if zero
{ "jrnz",	CF_USE1                         },      // jump no carry
{ "jrr",	CF_USE1|CF_USE2|CF_USE3         },      // jump if bit is clear
{ "jrs",	CF_USE1|CF_USE2|CF_USE3         },      // Jump if Bit is set
{ "jp",		CF_USE1                         },      // Jump
{ "call",	CF_USE1|CF_CALL                 },      // function call
{ "ret",	CF_STOP                         },      // function return
{ "reti",	CF_STOP							},      // return from interrupt
{ "nop",	0				                },      // no operation
{ "stop",	0				                },      // stop mode
{ "wait",	0				                },      // wait mode
};

#ifdef __BORLANDC__
#if sizeof(Instructions)/sizeof(Instructions[0]) != ST6_last
#error          No match:  sizeof(InstrNames) !!!
#endif
#endif
