/*
 *      Interactive disassembler (IDA).
 *      Copyright (c) 1990-98 by Ilfak Guilfanov.
 *      ALL RIGHTS RESERVED.
 *                              E-mail: ig@estar.msk.su, ig@datarescue.com
 *                              FIDO:   2:5020/209
 *
 */

#ifndef _ST6_HPP
#define _ST6_HPP

#include "..\idaidp.hpp"
#include "ins.hpp"
#include <diskio.hpp>

//------------------------------------------------------------------------
// customization of the 'cmd' structure:

// indirect register number (for o_phrase):
#define indreg          specflag1

// ash.uflag bit meanings:

#define UAS_DEF			0x0001          // use BYTE for intram
#define RAMSEG			SEG_DATA
extern ea_t intram;

extern char device[MAXSTR];

//------------------------------------------------------------------------
// Registers
enum ST6_registers
{
	rA, rV, rW,rX,rY,rC, rZ, rPC,
	rVcs, rVds            // these 2 registers are required by the IDA kernel
};

//------------------------------------------------------------------------
void    header(void);
void    footer(void);

void    segstart(ea_t ea);

int     ana(void);
int     emu(void);
void    out(void);
int     outop(op_t &op);

void    ST6_data(ea_t ea);

#endif
